export var mkfile = function (name, meta) {
    if (meta === void 0) { meta = {}; }
    return ({
        name: name,
        meta: meta,
        type: "file",
    });
};
export var mkdir = function (name, children, meta) {
    if (meta === void 0) { meta = {}; }
    return ({
        name: name,
        children: children || [],
        meta: meta,
        type: "directory",
    });
};
export var getChildren = function (directory) { return directory.children; };
export var getMeta = function (node) { return node.meta; };
export var getName = function (node) { return node.name; };
export var isFile = function (node) { return node.type === "file"; };
export var isDirectory = function (node) { return node.type === "directory"; };
// const map = (callbackFn, tree) => {
//   const updatedNode = callbackFn(tree);
//   return isDirectory(tree)
//     ? { ...updatedNode, children: tree.children.map((n) => map(callbackFn, n)) }
//     : updatedNode;
// };
// const reduce = (callbackFn, tree, acc) => {
//   const newAcc = callbackFn(acc, tree);
//   if (isFile(tree)) {
//     return newAcc;
//   }
//   return tree.children.reduce((iAcc, n) => reduce(callbackFn, n, iAcc), newAcc);
// };
// const filter = (callbackFn, tree) => {
//   if (!callbackFn(tree)) {
//     return null;
//   }
//   return isDirectory(tree)
//     ? {
//         ...tree,
//         children: tree.children
//           .map((n) => filter(callbackFn, n))
//           .filter((v) => v),
//       }
//     : tree;
// };
