import { describe, test, expect } from "vitest";
import { mkdir, mkfile } from "./immutableFsTree";

describe.concurrent("Immutable Fs Tree", () => {
  test("mdkir is a function", () => {
    expect(mkdir).toBeTypeOf("function");
  });
  test("can make folder and file", () => {
    expect(mkdir("project")).toHaveProperty("name", "project");
    expect(mkdir("project")).toHaveProperty("children", []);
    expect(mkfile("index.html")).toHaveProperty("name", "index.html");
  });
});
